<?php

namespace Drupal\Tests\sdc\Unit;

use Drupal\KernelTests\KernelTestBase;
use Drupal\sdc\Utilities;

/**
 * @coversDefaultClass \Drupal\sdc\Utilities
 * @group sdc
 */
class UtilitiesTest extends KernelTestBase {

  protected static $modules = ['sdc'];

  /**
   * @covers ::makePathRelative
   */
  public function testMakePathRelative(): void {
    // We cannot use the data provider because the container is not ready in the
    // data provider.
    $app_root = \Drupal::root();
    $test_data = [
      ['', '', './'],
      [
        "$app_root/foo/bar/baz",
        "$app_root/foo/lorem/ipsum/dolor",
        '../../../../foo/bar/baz',
      ],
      [
        "$app_root/foo/bar/baz",
        "$app_root/foo/bar/baz",
        '../../../foo/bar/baz',
      ],
      [
        "$app_root/foo/bar/baz",
        "foo/lorem/ipsum/dolor",
        '../../../../foo/bar/baz',
      ],
      [
        "foo/bar/baz",
        "$app_root/foo/lorem/ipsum/dolor",
        '../../../../foo/bar/baz',
      ],
      [
        "foo/bar/baz",
        "foo/lorem/ipsum/dolor",
        '../../../../foo/bar/baz',
      ],
    ];
    foreach ($test_data as $test_datum) {
      [$full_path, $base, $expected] = $test_datum;
      $this->assertSame(
        $expected,
        Utilities::makePathRelative($full_path, $base)
      );
    }
  }

}
